#!/bin/sh
# Under GPL ver 2.0 and upper.
# Copylefted by hip0.
# Use at your own risk.
# sync-mail-dir.sh 
# Put this script on a crontab on the mail server you synchronize data to.
############# Synchronization Setup Section ##############
# username to login as.
username='root';
# hostname to sync to.
hostname='design.bg';
# lock file to use
lock_f=/tmp/sync_mail_lock
# / at the end of the directory for syncing the whole dir.
mail_dir=/var/vpopmail/domains/;
# rsync options
opts="-aze ssh";
# rsync binary location.
rs_bin=/usr/bin/rsync;

############# Check is the sync machine alive and well. Setup Section  ##############
# box to check
box='207.36.180.31';
# external box to check
box1='68.142.226.42';
# port number to use
port_num=22;
# nmap parameters
scanner_stuff="/usr/bin/nmap -P0 -p $port_num";
# port state to match for
op='open';
log_file=/var/log/sync-mail.log
#############

PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/X11R6/bin:/var/qmail/bin:/usr/local/bin:/var/vpopmail/bin

if [ "`$scanner_stuff ${box} | grep open | awk '{ print $2 }'`" != "$op" ]; then
echo "$(date): ${box} is down. Possible network or ${box} problem."\
>> $log_file;
exit 1;
fi

if [ -z "$($scanner_stuff ${box1} | grep "(1 host up)")" ]; then
touch ${lock_f};
echo "$(date): ${box1} is down. Possible network problem."\
>> $log_file;
fi

if [[ -n $(pgrep -l rsync) ]]; then
exit 0;
fi

if [ -n "`ssh ${username}@${hostname} "if
[[ -f $lock_f ]]; then echo 1; fi" | grep 1 `" ]; \
then 

${rs_bin} ${opts} ${mail_dir} ${hostname}:${mail_dir};
ssh ${username}@${hostname} "rm -f $lock_f";
fi
